package xxmath.frame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.Timer;

/**
 * Ԃ\plB
 * 
 * @author Ryo IKEDA
 */
class TimePanel extends JPanel {

    /** v鎞(b) */
    private int second;

    /** ԕ\p̕ */
    private String timeText = "oߎ: ";
    
    /** ԕ\px */
    private JLabel lbTime = new JLabel("", JLabel.CENTER);

    /** 1bƂɃJEg^C}[ */
    private Timer timer = new Timer(1000, new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            second++;
            setText();
        }
    });

    /**
     * RXgN^B
     */
    TimePanel() {
        add(lbTime);
        setText();
    }

    /**
     * ԃJEgX^[gB
     */
    void start() {
        timer.start();
    }

    /**
     * ԃJEgXgbvB
     */
    void stop() {
        timer.stop();
    }

    /**
     * ԂXgbv0ɖ߂B
     */
    void clear() {
        stop();
        second = 0;
        setText();
    }

    /**
     * ԂZbgB
     */
    private void setText() {
        lbTime.setText(timeText + getTimeText());
    }

    /**
     * ݂̕bmm:ss`̕ɂĕԂB
     * 
     * @return
     */
    private String getTimeText() {
        int m = second / 60;
        int s = second % 60;

        return formatTime(m) + ":" + formatTime(s);
    }

    /**
     * Ԃ𕶎ɂB
     * 1Ȃ0𑫂ɂB
     * 
     * @param time 
     * @return
     */
    private String formatTime(int time) {
        if (time < 10) {
            return 0 + "" + time;
        }
        return "" + time;
    }

}
