package xxmath.util;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import static java.awt.event.KeyEvent.*;

import javax.swing.text.JTextComponent;

/**
 * eLXgR|[lgł̐̓͐pL[Xi[B
 * 
 * @author Ryo IKEDA
 */
public class DigitKeyListener extends KeyAdapter {

    /** ͍ő啶 */
    private int maxDigit;

    /** -(}CiX)̓͂ǂ */
    private boolean isAllowedMinus;

    /**
     * ő啶w肹A}CiXRXgN^B
     * 
     * @param maxDigit ő啶
     */
    public DigitKeyListener() {
        this(Integer.MAX_VALUE, true);
    }

    /**
     * ő啶w肵A}CiXRXgN^B
     * 
     * @param maxDigit ő啶
     */
    public DigitKeyListener(int maxDigit) {
        this(maxDigit, true);
    }

    /**
     * ő啶ƃ}CiXǂݒ肷RXgN^B
     * 
     * @param maxDigit ő啶
     * @param okMinus }CiXǂ
     */
    public DigitKeyListener(int maxDigit, boolean okMinus) {
        this.maxDigit = maxDigit;
        this.isAllowedMinus = okMinus;
    }

    /**
     * ͍ő啶ԂB
     */
    public int getMaxDigit() {
        return maxDigit;
    }

    /**
     * ͍ő啶ݒ肷B
     */
    public void setMaxDigit(int maxDigit) {
        this.maxDigit = maxDigit;
    }

    /**
     * -(}CiX)̓͂ǂԂB
     */
    public boolean isAllowedMinus() {
        return isAllowedMinus;
    }

    /**
     * -(}CiX)̓͂ǂݒ肷B
     */
    public void setAllowedMinus(boolean isAllowedMinus) {
        this.isAllowedMinus = isAllowedMinus;
    }

    @Override
    public void keyTyped(KeyEvent e) {
        JTextComponent tf = (JTextComponent)e.getSource();

        char key = e.getKeyChar();
        int length = tf.getText().length();
        int start = tf.getSelectionStart();
        int end = tf.getSelectionEnd();

        // '-'̓eLXgtB[h󂩑SIԂ̂Ƃ
        if (isAllowedMinus && (key == VK_MINUS || key == VK_EQUALS)
                && (length == 0 || end - start == length)) {
            return;
        }

        // ȊOȂ
        if (key < VK_0 || VK_9 < key) {
            e.consume();
            return;
        }

        // 1ڂ-͌ɐAw̌ȏ̓͂͋Ȃ
        if (length >= 1 && tf.getText().charAt(0) == '-') {
            length--;
        }
        if (length >= maxDigit && tf.getSelectedText() == null) {
            e.consume();
            return;
        }
    }

}
