package xxmath.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * ݒt@CǂݏNXB
 */
public class Config {

    private final Properties p;
    private final File configfile;

    /**
     * RXgN^B
     * 
     * @param path t@CpX
     * @throws NullPointerException null̏ꍇ
     */
    public Config(String path) {
        if (path == null) {
            throw new NullPointerException();
        }
        p = new Properties();
        configfile = new File(path);
    }

    /**
     * XMLt@CvpeBǂݍށB
     */
    public void loadXML() throws FileNotFoundException, IOException {
        FileInputStream in = null;
        try {
            in = new FileInputStream(configfile);
            p.loadFromXML(in);
        } finally {
            if (in != null) {
                in.close();
            }
        }
    }

    /**
     * XMLt@CɃvpeBށB
     */
    public void saveXML() throws FileNotFoundException, IOException {
        FileOutputStream out = null;
        try {
            out = new FileOutputStream(configfile);
            p.storeToXML(out, null);
        } finally {
            if (out != null) {
                out.close();
            }
        }
    }

    /**
     * vpeB̃\bhĂԁB
     * 
     * @param key vpeBL[
     * @return w肳ꂽL[̒lBȂꍇnull
     */
    public String get(String key) {
        return p.getProperty(key);
    }

    /**
     * vpeB̃\bhĂԁB
     * 
     * @param key vpeBL[
     * @return w肳ꂽL[̒lBȂꍇnull
     * @throws NumberFormatException
     */
    public int getInteger(String key) {
        return Integer.parseInt(p.getProperty(key));
    }

    /**
     * vpeB̃\bhĂԁB
     * 
     * @param key vpeBL[
     * @return L[̑O̒lBȂꍇnull
     */
    public Object set(String key, String value) {
        return p.setProperty(key, value);
    }

    /**
     * vpeB̃\bhĂԁB
     * 
     * @param key vpeBL[
     * @return L[̑O̒lBȂꍇnull
     */
    public Object setInteger(String key, int value) {
        return p.setProperty(key, String.valueOf(value));
    }

}
